/*
 * DECODE.h
 *
 *  Created on: 07.11.2018
 *      Author: Maxi
 */

#ifndef DECODE_H_
#define DECODE_H_
/*
#define WIN32  // uncomment this line to use it for windows. 
#ifdef WIN32
#include <direct.h>
#define GetCurrentDir _getcwd
#else
#include <unistd.h>
#define GetCurrentDir getcwd
#endif
*/


#include "PAD.h"
#include "CopyFunc.h"
#include <iostream>
#include <fstream>
#include <stdio.h>//for memcpy
#include <string.h>//for memcpy
#include <vector>//für the vector algorithms
#include <unistd.h>


//using namespace std;

class DECODE {
private:
    //Attributes
    bool bEGNOS=1;
    bool bGPS=1;
    bool bGLONASS=1;
    bool bGALILEO=1;
    int iSatVectorSize;
    int iTranslationMode;
    int iPathCount;
    int iCoordinatesCount;
    int iImuSampleCount;
    unsigned short lengthPayload;
    float fProgress;
    char *pcArray;//pointer which points to the character stream 
    std::string strPath;
    std::ifstream stream_UBXdata;//input file
    std::ofstream stream_TXTdata;//output file
    PAD *padsolution=new PAD;
    //Methods
    int choiceFormat();
    void writeHeaderCsv(int &iFormat);
    void writeHeaderKml();
    void translateUbxToKml();
    void writeToCsv(int &iFormat);
    void writeToKml(int &iMode);
    void identifyUbxMsg(int iTypeOfFile,int iExtraParameter);
    void resetPointers();
    void inflateSatellite();
    void tellProgress(int64_t &iMaximumSize, int64_t&iKnownBytes);
protected:
public:
    //Constructor and destructor
    DECODE();
    DECODE(std::string newPath);//loaded constructor
    virtual ~DECODE();
    //Methods
    void decodeUbxToKml();
    void decodeUbxToCsv(int iFormat);
    void choiceFileType();
};


#endif /* DECODE_H_ */
